#!/usr/bin/env python3
import sys
import collections

if int(sys.argv[1]) == -1:
    data_list = ['heart_scale']
elif int(sys.argv[1]) == 0:
    data_list = ['rcv1_test']
else:
    data_list = ['kdda', 'kdd12', 'eps', 'avazu-app', 'higgs', 'url', 'criteo', 'web_trigram', 'splice_site_t_0_1', 'rcv1_test']

datas_path_dict = {\
'heart_scale':'./data/heart_scale',\
'avazu-app':'./data/avazu-app',\
'criteo':'./data/criteo.tr.svm', \
'eps':'./data/epsilon_normalized', \
'higgs':'./data/HIGGS', \
'kdda':'./data/kdda',\
'kdd12':'./data/kdd12', \
'rcv1_test':'./data/rcv1_test', \
'url':'./data/url_combined', \
'web_trigram':'./data/webspam_wc_normalized_trigram',\
'splice_site_t_0_1':'./data/splice_site.t.0.1'
}



for data in data_list:
    input_path = datas_path_dict[data]
    nnz_per_feat_output_path = input_path + '.nnz.per.feat'
    nnz_per_inst_output_path = input_path + '.nnz.per.inst'


    nnz_per_feat_dict = collections.defaultdict(int)

    with open(nnz_per_inst_output_path, 'w') as out:
        for line in open(input_path):
            line = line.strip().split()
            feats = line[1:]
            indices = [int(x.split(':')[0]) for x in feats]

            num_feats = len(indices)

            out.write('{0}\n'.format(num_feats))

            if len(indices) == 0:
                indices = [0]

            for feat in indices:
                nnz_per_feat_dict[feat] += 1

    with open(nnz_per_feat_output_path, 'w') as out:
        for key in sorted(nnz_per_feat_dict.keys()):
            out.write('{0}\n'.format(nnz_per_feat_dict[key]))
