import os, sys

if int(sys.argv[1]) == -1:
    data_list = ['heart_scale']
elif int(sys.argv[1]) == 0:
    data_list = ['rcv1_test']
else:
    data_list = ['kdda', 'kdd12', 'eps', 'avazu-app', 'higgs', 'url', 'criteo', 'web_trigram', 'splice_site_t_0_1', 'rcv1_test']

datas_path_dict = {\
'heart_scale':'./data/heart_scale',\
'avazu-app':'./data/avazu-app',\
'criteo':'./data/criteo.tr.svm', \
'eps':'./data/epsilon_normalized', \
'higgs':'./data/HIGGS', \
'kdda':'./data/kdda',\
'kdd12':'./data/kdd12', \
'rcv1_test':'./data/rcv1_test', \
'url':'./data/url_combined', \
'web_trigram':'./data/webspam_wc_normalized_trigram',\
'splice_site_t_0_1':'./data/splice_site.t.0.1'
}

data_path_dict = {\
'heart_scale':['./data/heart_scale.nnz.per.inst.percentile', './data/heart_scale.nnz.per.feat.percentile'],\
'avazu-app':['./data/avazu-app.nnz.per.inst.percentile', './data/avazu-app.nnz.per.feat.percentile'],\
'criteo':['./data/criteo.tr.svm.nnz.per.inst.percentile', './data/criteo.tr.svm.nnz.per.feat.percentile'],\
'eps':['./data/epsilon_normalized.nnz.per.inst.percentile', './data/epsilon_normalized.nnz.per.feat.percentile'],\
'higgs':['./data/HIGG.nnz.per.inst.percentile', './data/HIGG.nnz.per.feat.percentile'],\
'kdda':['./data/kdda.nnz.per.inst.percentile', './data/kdda.nnz.per.feat.percentile'],\
'kdd12':['./data/kdd12.nnz.per.inst.percentile', './data/kdd12.nnz.per.feat.percentile'],\
'rcv1_test':['./data/rcv1_test.nnz.per.inst.percentile', './data/rcv1_test.nnz.per.feat.percentile'],\
'url':['./data/url_combined.nnz.per.inst.percentile', './data/url_combined.nnz.per.feat.percentile'],\
'web':['./data/webspam_wc_normalized_trigram.nnz.per.inst.percentile', './data/webspam_wc_normalized_trigram.nnz.per.feat.percentile'],\
'splice_site_t_0_1':['./data/splice_site.t.0.1.nnz.per.inst.percentile', './data/splice_site.t.0.1.nnz.per.feat.percentile']
}

name_mapping_dict  = \
{\
    'heart_scale':'heart\_scale', \
    'avazu-app':'\\avazuapp', \
    'kdd12':'\\kddtwelve', \
    'yk':'\\yk',\
    'rcv1_test':'\\rcvone', \
    'eps':'\\eps', \
    'higgs':'\\higgs', \
    'url':'\\urlcombined',\
    'criteo':'\\criteo', \
    'web':'\\webspam',
    'kdda':'\\kdda',\
    'splice_site_t_0_1':'\\splice'
}

def get_stats(data_path, threshold):
    val_list = []
    count_sum = 0
    count = 0
    for line in open(data_path):
        val, fraction = map(float, line.split())
        if fraction > threshold:
            break
        else:
            count_sum += val
            count += 1
    l = 0
    for line in open(data_path):
        l += 1

    return count*1.0/l, val, count_sum*1.0/count

def add_comma2float(val_str):
    return '{:,.6f}'.format(float(val_str))

def add_comma2int(val_str):
    return '{:,d}'.format(int(val_str))

threshold_1 = 0.5
threshold_2 = 0.8

for data in data_list:
    inst_percentile_path, feat_percentile_path = data_path_dict[data]

    inst_a, inst_nnza, inst_mean_nnza = get_stats(inst_percentile_path, 0.5)
    inst_b, inst_nnzb, inst_mean_nnzb = get_stats(inst_percentile_path, 0.8)
    feat_a, feat_nnza, feat_mean_nnza = get_stats(feat_percentile_path, 0.5)
    feat_b, feat_nnzb, feat_mean_nnzb = get_stats(feat_percentile_path, 0.8)

    #inst_a, inst_b, feat_a, feat_b, inst_mean_nnza, inst_mean_nnzb, feat_mean_nnza, feat_mean_nnzb  = map(add_comma2float, [inst_a, inst_b, feat_a, feat_b, inst_mean_nnza, inst_mean_nnzb, feat_mean_nnza, feat_mean_nnzb])
    inst_a, inst_b, feat_a, feat_b= map(add_comma2float, [inst_a, inst_b, feat_a, feat_b])
    inst_mean_nnza, inst_mean_nnzb, feat_mean_nnza, feat_mean_nnzb  = map(add_comma2int, [inst_mean_nnza, inst_mean_nnzb, feat_mean_nnza, feat_mean_nnzb])
    inst_nnza, inst_nnzb, feat_nnza, feat_nnzb = map(add_comma2int, [inst_nnza, inst_nnzb, feat_nnza, feat_nnzb])

    print '&'.join(map(str, [name_mapping_dict[data], inst_a, inst_b, inst_nnza, inst_nnzb, inst_mean_nnza, inst_mean_nnzb, feat_a, feat_b, feat_nnza, feat_nnzb, feat_mean_nnza, feat_mean_nnzb])) + '\\\\'
