import os, sys
import collections

if int(sys.argv[1]) == -1:
    data_list = ['heart_scale']
elif int(sys.argv[1]) == 0:
    data_list = ['url']
else:
    data_list = ['avazu-app', 'criteo', 'eps', 'split_site_t_0_1', 'url', 'web']

data_path_cddual_dict = {\
'heart_scale':'./heart_scale.cddual.speedup.log',\
'avazu-app':'./avazu-app.cddual.speedup.log',\
'criteo':'./criteo.cddual.speedup.log',\
'eps':'./eps.cddual.speedup.log',\
'split_site_t_0_1':'./split_site_t_0_1.cddual.speedup.log',\
'url':'./url.cddual.speedup.log',\
'web':'./web_trigram.cddual.speedup.log',\
}


name_mapping_dict  = \
{\
    'heart_scale':'heart\_scale',\
    'avazu-app':'\\avazuapp', \
    'avazu-site':'\\avazusite',\
    'criteo':'\\criteo',\
    'eps':'\\eps', \
    'split_site_t_0_1':'\\splice',\
    'url':'\\urlcombined', \
    'web':'\\webspam', \
}

def parse_log(filepath):
    obj_list = []
    time_list = []
    for line in open(filepath):
        if 'obj' in line:
            line = line.strip().split()
            time_list.append(float(line[5].split(',')[0]))
            obj_list.append(float(line[-1]))
    return [obj_list, time_list]

def parse_bcdn_log(filepath):
    obj_list = []
    time_list = []
    for line in open(filepath):
        if line.startswith('iter'):
            line = line.strip().split()
            time_list.append(float(line[5]))
            obj_list.append(float(line[9]))
    return [obj_list, time_list]

def parse_lr_log(filepath):
    res = []
    for line in open(filepath):
        if 'obj' in line:
            line = float(line.strip().split()[3].split(',')[0].split('=')[-1])
            res.append(line)
    return res


def print_speedup(log_dict, baseline_log_dict, solver):
    if len(log_dict.keys()) == 0:
        for key in [2, 4, 8]:
            print '&   ',
        return

    if (solver == 'cddual' or solver == 'cdn') and (log_dict[1][0][-1] == log_dict[8][0][-1]):
        baseline_obj = min(baseline_log_dict[1][0])
        baseline_obj_list = baseline_log_dict[1][0]
        baseline_time_list = baseline_log_dict[1][1]

        baseline_index_list = [i for i, fun_val in enumerate(baseline_obj_list) if fun_val > baseline_obj]
        baseline_index = max(baseline_index_list)
        baseline_time = (baseline_time_list[baseline_index] + baseline_time_list[baseline_index + 1])*1.0/2
    else:
        min_obj = min(baseline_log_dict[1][0])
        #baseline_obj = min_obj * 1.008
        baseline_obj = min_obj * 1.005
        baseline_obj_list = baseline_log_dict[1][0]
        baseline_time_list = baseline_log_dict[1][1]

        baseline_index_list = [i for i, fun_val in enumerate(baseline_obj_list) if fun_val > baseline_obj]
        baseline_index = max(baseline_index_list)
        baseline_time = (baseline_time_list[baseline_index] + baseline_time_list[baseline_index + 1])*1.0/2

    for key in sorted(log_dict.keys()):
        if key == 1 or key == 16: continue
        obj_list = log_dict[key][0]
        time_list = log_dict[key][1]

        if min(obj_list) > baseline_obj:
            print '&   x',
        else:
            index_list = [i for i, fun_val in enumerate(obj_list) if fun_val > baseline_obj]
            if len(index_list) == 0:
                print '&   x',
                continue
            index = max(index_list)
            if index + 1 == len(time_list):
                print '&   x',
                continue
            current_time = (time_list[index] + time_list[index + 1])*1.0/2

            ratio = baseline_time*1.0/current_time
            if ratio > 0.1:
                print '&   {0:.1f}'.format(round(baseline_time*1.0/current_time, 1)),
            else:
                print '&   x',

for data in data_list:
    cddual_svm_nothreshold_log_dict = collections.defaultdict(list)
    for root, dirs, files in os.walk(data_path_cddual_dict[data]):
        for filename in files:
            filepath = os.path.join(root, filename)
            num_threads = int(filename.split('.')[1])

            if 'shrink' in filename: continue

            if filename.startswith('cdn'):
                if 'svm' in filename:
                    if 'm0' in filename:
                        cdn_svm_nothreshold_log_dict[num_threads] = parse_log(filepath)
                    elif 'm500' in filename:
                        continue
                    else:
                        cdn_svm_threshold_log_dict[num_threads] = parse_log(filepath)
                elif 'lr' in filename:
                    if 'm0' in filename:
                        cdn_lr_nothreshold_log_dict[num_threads] = parse_log(filepath)
                    elif 'm500' in filename:
                        continue
                    else:
                        cdn_lr_threshold_log_dict[num_threads] = parse_log(filepath)
                else:
                    continue
            elif filename.startswith('cddual'):
                if 'm500' in filename:
                    cddual_svm_threshold_log_dict[num_threads] = parse_log(filepath)
                elif 'm0' in filename:
                    cddual_svm_nothreshold_log_dict[num_threads] = parse_log(filepath)
                continue
            else:
                continue
    print '{0} '.format(name_mapping_dict[data]),
    print_speedup(cddual_svm_nothreshold_log_dict, cddual_svm_nothreshold_log_dict, 'cddual'),
    print '\\\\'
